﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace XDGInfiniteHierarchyDemo
{
    public class ViewModel
    {
        public ObservableCollection<SampleData> Data { get; set; }

        Random r = new Random();
        public ViewModel()
        {
            Data = new ObservableCollection<SampleData>();

            for(int i=0; i<25; i++)
            {
                SampleData sd = new SampleData() { ID = i, Label = "Parent " + i.ToString(), Number = r.Next(1000), Date = DateTime.Today.AddDays(i) };
                sd.Children = new ObservableCollection<SampleData>();

                for(int j=0; j<10; j++)
                {
                    SampleData sdChild = new SampleData() { ID = j, Label = "Child " + j.ToString(), Number = r.Next(1000), Date = DateTime.Today.AddMonths(i) };
                    sdChild.Children = new ObservableCollection<SampleData>();

                    for(int k=0; k<5; k++)
                    {
                        SampleData sdGrandchild = new SampleData() { ID = k, Label = "Grandchild " + k.ToString(), Number = r.Next(1000), Date = DateTime.Today.AddYears(k) };
                        sdChild.Children.Add(sdGrandchild);
                    }

                    sd.Children.Add(sdChild);
                }

                Data.Add(sd);
            }
        }
    }

    public class SampleData
    {
        public int ID { get; set; }
        public string Label { get; set; }
        public int Number { get; set; }
        public DateTime Date { get; set; }
        public ObservableCollection<SampleData> Children { get; set; }
    }
}
